;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;
;	Knihovna komunikace po domovni sbernici
;
;	Procesor:	PIC
;	Rychlost:	4MHz
;
;	02/2016 Milan rajer
;
;-------------------------------------------------------------------------------
;
;	call	res_bus		<- vysle reset impuls
;	call	w_bus		<- vysle byte W na sbernici
;	call	bus_dat		<- prijme byte ze sbernice a ulozi do registru DAT
;	call	bus_rw		<- casova prodleva pred zacatkem vysilani
;
;-------------------------------------------------------------------------------
;
;	Pozadavky - registry:
;	------------------------
;	DAT - pracovni registr
;
;	CEK1 - registr casovych smycek
;
;
;	Pozadavky - piny:
;	------------------------
;	BUS - pin sbernice
;	BUS_T - pozice pinu BUS v registru TRIS	(#define	BUS_T	TRISC,0)
;
;-------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;	Vyslani reset impulsu
;--------------------------------------------------------------------------------
res_bus	bcf	BUS		;pin BUS permanentne v log 0
	call	bus_out
	call	c1m
	call	bus_in
	call	b_c20u
;       ------------------------
	return
;-------------------------------------------------------------------------------
;	Vyslani W na sbernici
;-------------------------------------------------------------------------------
w_bus	bcf	BUS		;pin BUS permanentne v log 0
	movwf	DAT		;W do DAT
;       ------------------------
	btfsc	DAT,0		;bit 0
	call	lo1_bus
	btfss	DAT,0
	call	lo0_bus
;       ------------------------
	btfsc	DAT,1		;bit 1
	call	lo1_bus
	btfss	DAT,1
	call	lo0_bus
;       ------------------------
	btfsc	DAT,2		;bit 2
	call	lo1_bus
	btfss	DAT,2
	call	lo0_bus
;       ------------------------
	btfsc	DAT,3		;bit 3
	call	lo1_bus
	btfss	DAT,3
	call	lo0_bus
;       ------------------------
	btfsc	DAT,4		;bit 4
	call	lo1_bus
	btfss	DAT,4
	call	lo0_bus
;       ------------------------
	btfsc	DAT,5		;bit 5
	call	lo1_bus
	btfss	DAT,5
	call	lo0_bus
;       ------------------------
	btfsc	DAT,6		;bit 6
	call	lo1_bus
	btfss	DAT,6
	call	lo0_bus
;       ------------------------
	btfsc	DAT,7		;bit 7
	call	lo1_bus
	btfss	DAT,7
	call	lo0_bus
;       ------------------------
	return
;-------------------------------
;	Vysle bit 0
;-------------------------------
lo0_bus	call	bus_out
	call	b_c80u
	call	bus_in
	call	b_c20u	
;       ------------------------
	return
;-------------------------------
;	Vysle bit 1
;-------------------------------
lo1_bus	call	bus_out
	call	b_c20u
	call	bus_in
	call	b_c80u	
;       ------------------------
	return
;-------------------------------
;	Nastaveni pinu BUS
;-------------------------------
bus_in	bsf	STATUS,RP0	;banka 1
	bcf	STATUS,RP1
	bsf	BUS_T		;BUS vstupni
	bcf	STATUS,RP0	;banka 0
;	------------------------
	return
;-------------------------------
bus_out	bsf	STATUS,RP0	;banka 1
	bcf	STATUS,RP1
	bcf	BUS_T		;BUS vstupni
	bcf	STATUS,RP0	;banka 0
;	------------------------
	return
;-------------------------------------------------------------------------------
;	Prijem byte ze sbernice, vraci DAT
;-------------------------------------------------------------------------------
bus_dat	call	startb
;       ------------------------
	call	b_c50u		;cekej 50us po sestupne hrane a pak precti uroven
	btfss	BUS
	bcf	DAT,0
	btfsc	BUS
	bsf	DAT,0	
;-------------------------------
	call	startb
;       ------------------------
	call	b_c50u		;cekej 50us po sestupne hrane a pak precti uroven
	btfss	BUS
	bcf	DAT,1
	btfsc	BUS
	bsf	DAT,1	
;-------------------------------
	call	startb
;       ------------------------
	call	b_c50u		;cekej 50us po sestupne hrane a pak precti uroven
	btfss	BUS
	bcf	DAT,2
	btfsc	BUS
	bsf	DAT,2
;-------------------------------
	call	startb
;       ------------------------
	call	b_c50u		;cekej 50us po sestupne hrane a pak precti uroven
	btfss	BUS
	bcf	DAT,3
	btfsc	BUS
	bsf	DAT,3
;-------------------------------
	call	startb
;       ------------------------
	call	b_c50u		;cekej 50us po sestupne hrane a pak precti uroven
	btfss	BUS
	bcf	DAT,4
	btfsc	BUS
	bsf	DAT,4
;-------------------------------
	call	startb
;       ------------------------
	call	b_c50u		;cekej 50us po sestupne hrane a pak precti uroven
	btfss	BUS
	bcf	DAT,5
	btfsc	BUS
	bsf	DAT,5
;-------------------------------
	call	startb
;       ------------------------
	call	b_c50u		;cekej 50us po sestupne hrane a pak precti uroven
	btfss	BUS
	bcf	DAT,6
	btfsc	BUS
	bsf	DAT,6
;-------------------------------
	call	startb
;       ------------------------
	call	b_c50u		;cekej 50us po sestupne hrane a pak precti uroven
	btfss	BUS
	bcf	DAT,7
	btfsc	BUS
	bsf	DAT,7
;-------------------------------
	return
;-------------------------------
;	Detekce zacatku bitu
;-------------------------------
startb	movlw	.38		;cekej max 150us na log 1
        movwf	CEK1
;       ------------------------
	btfsc	BUS		;pokud se objevi, pokracuj v prijmu
	goto	sestup
;       ------------------------
	decfsz	CEK1,1
        goto	$-3
;       ------------------------
	return			;..jinak se vrat
;-------------------------------
sestup	movlw	.38		;cekej max 150us na log 0
        movwf	CEK1
;       ------------------------
	btfss	BUS		;pokud se objevi, pokracuj v prijmu
	return
;       ------------------------
	decfsz	CEK1,1
        goto	$-3
;       ------------------------
	return			;..jinak se vrat
;-------------------------------------------------------------------------------
;	Cekaci smycky
;-------------------------------------------------------------------------------
bus_rw	movlw	.30		;100us
        movwf	CEK1
;       ------------------------
        decfsz	CEK1,F
        goto	$-1
;       ------------------------
	return
;-------------------------------
b_c20u	movlw	.2		;(33)
        movwf	CEK1
;       ------------------------
        decfsz	CEK1,F
        goto	$-1
;       ------------------------
	return
;-------------------------------
b_c50u	movlw	.15		;(83)
        movwf	CEK1
;       ------------------------
        decfsz	CEK1,F
        goto	$-1
;       ------------------------
	return
;-------------------------------
b_c80u	movlw	.23		;(132)
        movwf	CEK1
;       ------------------------
        decfsz	CEK1,F
        goto	$-1
;       ------------------------
	return
;-------------------------------
c1m	movlw	.27		;(8)
        movwf	CEK2
        movlw	.11		;(207)
        movwf	CEK1
;       ------------------------
        decfsz	CEK1,F
        goto	$-1
        decfsz	CEK2,F
        goto	$-5
;       ------------------------
	return
;-------------------------------------------------------------------------------